#include <os.h>
#include <cstdlib>
#include <ctime>
#include <n2dlib.c>
int maze_w=40,maze_h=30,player_x,player_y,steps,cleared,player_w,player_h;
bool v_walls[320][239],h_walls[319][240],visited[320][240];
enum option{menu,play}action=menu;
Rect player;
#include "stuff.h"
#include "recursivebacktracker.h"
#include "aldousbroder.h"
#include "binarytree.h"
int main()
{
	srand(time(NULL));
	initBuffering();
	while(1)
	{
		switch(action)
		{
		case menu:
			clearBufferW();
			drawString(20,10,"MAZES",0);
			drawString(20,20,"Press number to generate",0);
			drawString(20,30,"1. Recursive Backtracker (DFS)",0);
			drawString(20,40,"2. Aldous Broder",0);
			drawString(20,50,"3. Binary Tree",0);
			drawString(20,190,"Press M to modify maze size",0);
			drawString(20,200,"Try to reach the upper left",0);
			drawString(20,210,"Press 4 5 6 8 to move in the maze",0);
			drawString(20,220,"Press Q/ESC to quit",0);
			drawString(20,230,"Maze size:",0);
			drawString(123,230,"x",0);
			drawDecimal(100,230,maze_w,0);
			drawDecimal(130,230,maze_h,0);
			updateScreen();
			wait_key_pressed();
			if(isKeyPressed(KEY_NSPIRE_Q)||isKeyPressed(KEY_NSPIRE_ESC))
			{
				deinitBuffering();
				return 0;
			}
			else if(isKeyPressed(KEY_NSPIRE_1))
			{
				genmaze1();
				startPlay();
			}
			else if(isKeyPressed(KEY_NSPIRE_2))
			{
				genmaze2();
				startPlay();
			}
			else if(isKeyPressed(KEY_NSPIRE_3))
			{
				genmaze3();
				startPlay();
			}
			else if(isKeyPressed(KEY_NSPIRE_M))
			{
				setNewMazeSize();
			}
			break;
		case play:
			while(no_game_key_pressed())sleep(50);
			if(isKeyPressed(KEY_NSPIRE_Q))
			{
				deinitBuffering();
				timer_restore(0);
				return 0;
			}
			else if(isKeyPressed(KEY_NSPIRE_ESC))
			{
				action=menu;
				timer_restore(0);
			}
			else if(isKeyPressed(KEY_NSPIRE_P))
			{
				showpath();
			}
			else if((isKeyPressed(KEY_NSPIRE_4)||isKeyPressed(KEY_NSPIRE_LEFT))&&player_x>0&&v_walls[player_x-1][player_y]==0)
			{
				fillRect(320*player_x/maze_w,240*player_y/maze_h+1,player_w,player_h,0xffff);
				player_x--;
				fillRect(320*player_x/maze_w,240*player_y/maze_h+1,player_w,player_h,0b1111100000000000);
				updateScreen();
				while(isKeyPressed(KEY_NSPIRE_4)||isKeyPressed(KEY_NSPIRE_LEFT))sleep(50);
			}
			else if((isKeyPressed(KEY_NSPIRE_5)||isKeyPressed(KEY_NSPIRE_DOWN))&&player_y<maze_h-1&&h_walls[player_x][player_y]==0)
			{
				fillRect(320*player_x/maze_w,240*player_y/maze_h+1,player_w,player_h,0xffff);
				player_y++;
				fillRect(320*player_x/maze_w,240*player_y/maze_h+1,player_w,player_h,0b1111100000000000);
				updateScreen();
				while(isKeyPressed(KEY_NSPIRE_5)||isKeyPressed(KEY_NSPIRE_DOWN))sleep(50);
			}
			else if((isKeyPressed(KEY_NSPIRE_6)||isKeyPressed(KEY_NSPIRE_RIGHT))&&player_x<maze_w-1&&v_walls[player_x][player_y]==0)
			{
				fillRect(320*player_x/maze_w,240*player_y/maze_h+1,player_w,player_h,0xffff);
				player_x++;
				checkCompleted();
				fillRect(320*player_x/maze_w,240*player_y/maze_h+1,player_w,player_h,0b1111100000000000);
				updateScreen();
				while(isKeyPressed(KEY_NSPIRE_6)||isKeyPressed(KEY_NSPIRE_RIGHT))sleep(50);
			}
			else if((isKeyPressed(KEY_NSPIRE_8)||isKeyPressed(KEY_NSPIRE_UP))&&player_y>0&&h_walls[player_x][player_y-1]==0)
			{
				fillRect(320*player_x/maze_w,240*player_y/maze_h+1,player_w,player_h,0xffff);
				player_y--;
				checkCompleted();
				fillRect(320*player_x/maze_w,240*player_y/maze_h+1,player_w,player_h,0b1111100000000000);
				updateScreen();
				while(isKeyPressed(KEY_NSPIRE_8)||isKeyPressed(KEY_NSPIRE_UP))sleep(50);
			}
			break;
		}
	}
}